#uses "test/fwCtrlUtils/jsonSerializeDeserializeTestUtils.ctl"

void test_fwJsonDeserialize_optionsMap_setupSuite(){
  // No need for site setup currently
}

void test_fwJsonDeserialize_optionsMap_teardownSuite(){
  // No need for suite teardown currently
}

//void test_fwJsonDeserialize_optionsMap_setup(){}
//void test_fwJsonDeserialize_optionsMap_teardown(){}

void test_fwJsonDeserialize_optionsMap_acceptIncompleteJson_disabled(){
  dyn_errClass funcException;
  Test_Int deserializedVar;
  try{
    fwJsonDeserialize("{}", deserializedVar, makeMapping("acceptIncompleteJson", false));
  }catch{
    funcException = getLastException();
  }
  assertEqual(1, dynlen(funcException), "Exception should be thrown when JSON is incomplete and flag to accept this is set to false");
}

void test_fwJsonDeserialize_optionsMap_acceptIncompleteJson_singleParameterMissing(){
  Test_Bool sampleVal;
  Test_Bool deserializedVar;
  dyn_errClass funcException;
  try{
    fwJsonDeserialize("{}", deserializedVar, makeMapping("acceptIncompleteJson", true));
  }catch{
    funcException = getLastException();
  }
  assertEqual(0, dynlen(funcException), "An exception should not be thrown when JSON is incomplete but flag to accept this is set to true");
  assertEqual(sampleVal.c, deserializedVar.c, "Object property missing in JSON should be initialized with default value when acceptIncompleteJson=true");
}

void test_fwJsonDeserialize_optionsMap_acceptIncompleteJson_multipleParametersMissing(){
  const string sampleFile = "mapOfSimple/map_mixed_limited.json";
  string jsonString = readSample(sampleFile);
  Test_DerivedExt sampleVal = Test_DerivedExt::map2obj(SAMPLES_MAPPING[sampleFile]);
  Test_DerivedExt deserializedVar;
  dyn_errClass funcException;
  try{
    fwJsonDeserialize(jsonString, deserializedVar, makeMapping("acceptIncompleteJson", true));
  }catch{
    funcException = getLastException();
  }
  assertEqual(0, dynlen(funcException), "An exception should not be thrown when JSON is incomplete but flag to accept this is set to true");
  assertEqual(sampleVal, deserializedVar, "Object properties missing in JSON should be initialized with default value when acceptIncompleteJson=true");
}
